#include <fstream>
#include <cmath>
#include <iomanip>

using namespace std;

ifstream fin ("soricel.in");
ofstream fout ("soricel.out");

int cerinta, N, M, K, C[505][505], Golite_John[250010], D, gata;
int Smax, nrmax, nr, zile, zmax;

void citire()
{
   int i, j;
   fin >> cerinta;
   fin >> N >> M >> K;
   for (i = 1; i <= N; i++)
      for (j = 1; j <= M; j++)
         fin >> C[i][j];
   D = min (N, M) / 2; //John are de parcurs D dreptunghiuri
}

void Remy()
{
   int i, j;
   for (i = 1; i <= N; i++)
      for (j = 1; j <= M; j++)
         if (C[i][j])
         {
            C[i][j]--;
            gata = 0;
         }
}

int John()
{
   int i, j, d, S = 0, nr = 0, cateK = 0;
   int x;
   for (d = 1; d <= D; d++)
   {
      //orizontal sus
      for (j = d; j <= M - d + 1; j++)
         {
            x = sqrt (C[d][j]);
            if (x * x == C[d][j] && C[d][j])            //este patrat perfect
            {
               S += C[d][j];                 //adun la suma
               nr++;                         //numar cate sunt
               C[d][j] = 0;                  //le mananca
               cateK++;
            }
            else
            {
               if (nr >= nrmax)
               {
                  nrmax = nr;  //s-a terminat secventa
                  Smax = S;    //retin suma
                  zmax = zile; //retin ziua
               }
               nr = 0;      //resetez nr
               S = 0;       //reseez S
            }
         }
      //vertical in jos dreapta
      for (i = d + 1; i <= N - d + 1; i++)
         {
            x = sqrt (C[i][M - d + 1]);
            if (x * x == C[i][M - d + 1] && C[i][M - d + 1])   //este patrat perfect
            {
               S += C[i][M - d + 1];         //adun la suma
               nr++;                         //numar cate sunt
               C[i][M - d + 1] = 0;              //le mananca
               cateK++;
            }
            else
            {
               if (nr >= nrmax)
               {
                  nrmax = nr;  //s-a terminat secventa
                  Smax = S;    //retin suma
                  zmax = zile; //retin ziua
               }
               nr = 0;      //resetez nr
               S = 0;       //reseez S
            }
         }
      //orizontal jos
      for (j = M - d; j >= d; j--)
         {
            x = sqrt (C[N - d + 1][j]);
            if (x * x == C[N - d + 1][j] && C[N - d + 1][j])        //este patrat perfect
            {
               S += C[N - d + 1][j];             //adun la suma
               nr++;                             //numar cate sunt
               C[N - d + 1][j] = 0;              //le mananca
               cateK++;
            }
            else
            {
               if (nr >= nrmax)
               {
                  nrmax = nr;  //s-a terminat secventa
                  Smax = S;    //retin suma
                  zmax = zile; //retin ziua
               }
               nr = 0;      //resetez nr
               S = 0;       //reseez S
            }
         }
      //vertical in sus stanga
      for (i = N - d; i > d; i--)
         {
            x = sqrt (C[i][d]);
            if (x * x == C[i][d] && C[i][d])       //este patrat perfect
            {
               S += C[i][d];             //adun la suma
               nr++;                         //numar cate sunt
               C[i][d] = 0;                  //le mananca
               cateK++;
            }
            else
            {
               if (nr >= nrmax)
               {
                  nrmax = nr;  //s-a terminat secventa
                  Smax = S;    //retin suma
                  zmax = zile; //retin ziua
               }
               nr = 0;      //resetez nr
               S = 0;       //reseez S
            }
         }
   }
      //a mai ramas o linie pe orizontal sau pe vertical
      //orizontal
      if (N < M && N % 2)
         for (j = d; j <= M - d + 1; j++)
            {
               x = sqrt (C[d][j]);
               if (x * x == C[d][j] && C[d][j])          //este patrat perfect
               {
                  S += C[d][j];               //adun la suma
                  nr++;                         //numar cate sunt
                  C[d][j] = 0;                //le mananca
                  cateK++;
               }
               else
               {
                  if (nr >= nrmax)
                  {
                     nrmax = nr;  //s-a terminat secventa
                     Smax = S;    //retin suma
                     zmax = zile; //retin ziua
                  }
                  nr = 0;      //resetez nr
                  S = 0;       //reseez S
               }
            }

   if (N > M && M % 2)
      for (i = d; i <= N - d + 1; i++)
         {
            x = sqrt (C[i][d]);
            if (x * x == C[i][d] && C[i][d])     //este patrat perfect
            {
               S += C[i][d];           //adun la suma
               nr++;                         //numar cate sunt
               C[i][d] = 0;                //le mananca
               cateK++;
            }
            else
            {
               if (nr >= nrmax)
               {
                  nrmax = nr;  //s-a terminat secventa
                  Smax = S;    //retin suma
                  zmax = zile; //retin ziua
               }
               nr = 0;      //resetez nr
               S = 0;       //reseez S
            }
         }
      if (nr > nrmax)
      {
         nrmax = nr;  //s-a terminat secventa
         Smax = S;    //retin suma
         zmax = zile; //retin ziua
      }
   return cateK;
}

void afisare()
{
   int i, j;
   for (i = 1; i <= N; i++)
   {
      for (j = 1; j <= M; j++)
         fout << setw(3) << C[i][j] << ' ';
      fout << '\n';
   }
   fout << '\n';
}

int main()
{
   citire();
   zile = 0;
   gata = 0;
   //afisare();
   while (!gata)
   {
      gata = 1;
      zile++;
      Remy();
      //afisare();
      Golite_John[zile] = John();
      //fout << zile << '>' << Golite_John[zile] << '\n';
      //afisare();
   }
   if (cerinta == 1)
      fout << zile - 1 << ' ' << Golite_John[K] << '\n';
   else
      fout << nrmax << ' ' << zmax << '\n';
   return 0;
}
